diff --git a/src/load.c b/src/load.c
index fca02f7fa..903c3b8eb 100644
--- a/src/load.c
+++ b/src/load.c
@@ -113,6 +113,7 @@ static bool Load_Main(FILE *fp)
 			case 'UNIT': if (!Unit_Load     (fp, length)) return false; break;
 			case 'BLDG': if (!Structure_Load(fp, length)) return false; break;
 			case 'TEAM': if (!Team_Load     (fp, length)) return false; break;
+			case 'ODUN': if (!UnitNew_Load  (fp, length)) return false; break;
 
 			default:
 				Error("Unknown chunk in savegame: %c%c%c%c (length: %d). Skipped.\n", header, header >> 8, header >> 16, header >> 24, length);
diff --git a/src/save.c b/src/save.c
index b0f368feb..7bc41ac78 100644
--- a/src/save.c
+++ b/src/save.c
@@ -104,6 +104,7 @@ static bool Save_Main(FILE *fp, char *description)
 	if (!Save_Chunk(fp, "BLDG", &Structure_Save)) return false;
 	if (!Save_Chunk(fp, "MAP ", &Map_Save)) return false;
 	if (!Save_Chunk(fp, "TEAM", &Team_Save)) return false;
+	if (!Save_Chunk(fp, "ODUN", &UnitNew_Save)) return false;
 
 	/* Write the total length of all data in the FORM chunk */
 	length = ftell(fp) - 8;
diff --git a/src/saveload/saveload.h b/src/saveload/saveload.h
index 0f40a01f1..899f99526 100644
--- a/src/saveload/saveload.h
+++ b/src/saveload/saveload.h
@@ -143,4 +143,9 @@ extern bool Info_Load(FILE *fp, uint32 length);
 extern bool Info_LoadOld(FILE *fp, uint32 length);
 extern bool Info_Save(FILE *fp);
 
+extern bool Unit_Load(FILE *fp, uint32 length);
+extern bool Unit_Save(FILE *fp);
+extern bool UnitNew_Load(FILE *fp, uint32 length);
+extern bool UnitNew_Save(FILE *fp);
+
 #endif /* SAVELOAD_SAVELOAD_H */
diff --git a/src/saveload/unit.c b/src/saveload/unit.c
index 2cef06c8f..57073aade 100644
--- a/src/saveload/unit.c
+++ b/src/saveload/unit.c
@@ -25,7 +25,7 @@ static const SaveLoadDesc s_saveUnit[] = {
 	SLD_ENTRY (Unit, SLDT_UINT16, originEncoded),
 	SLD_ENTRY (Unit, SLDT_UINT8,  actionID),
 	SLD_ENTRY (Unit, SLDT_UINT8,  nextActionID),
-	SLD_ENTRY (Unit, SLDT_UINT8,  fireDelay),
+	SLD_ENTRY2(Unit, SLDT_UINT8,  fireDelay, SLDT_UINT16),
 	SLD_ENTRY (Unit, SLDT_UINT16, distanceToDestination),
 	SLD_ENTRY (Unit, SLDT_UINT16, targetAttack),
 	SLD_ENTRY (Unit, SLDT_UINT16, targetMove),
@@ -47,6 +47,17 @@ static const SaveLoadDesc s_saveUnit[] = {
 	SLD_END
 };
 
+static const SaveLoadDesc s_saveUnitNewIndex[] = {
+	SLD_ENTRY (Object, SLDT_UINT16, index),
+	SLD_END
+};
+
+static const SaveLoadDesc s_saveUnitNew[] = {
+	SLD_ENTRY (Unit, SLDT_UINT16, fireDelay),
+	SLD_EMPTY2(      SLDT_UINT16, 7),
+	SLD_END
+};
+
 
 /**
  * Load all Units from a file.
@@ -116,3 +127,63 @@ bool Unit_Save(FILE *fp)
 
 	return true;
 }
+
+/**
+ * Load all new information of Units from a file.
+ * @param fp The file to load from.
+ * @param length The length of the data chunk.
+ * @return True if and only if all bytes were read successful.
+ */
+bool UnitNew_Load(FILE *fp, uint32 length)
+{
+	while (length > 0) {
+		Unit *u;
+		Object o;
+
+		/* Read the next index from disk */
+		if (!SaveLoad_Load(s_saveUnitNewIndex, fp, &o)) return false;
+
+		length -= SaveLoad_GetLength(s_saveUnitNewIndex);
+
+		/* Get the Unit from the pool */
+		u = Unit_Get_ByIndex(o.index);
+		if (u == NULL) return false;
+
+		/* Read the "new" information for this unit */
+		if (!SaveLoad_Load(s_saveUnitNew, fp, u)) return false;
+
+		length -= SaveLoad_GetLength(s_saveUnitNew);
+	}
+	if (length != 0) return false;
+
+	return true;
+}
+
+/**
+ * Save all new Units information to a file. It converts pointers to indices
+ *   where needed.
+ * @param fp The file to save to.
+ * @return True if and only if all bytes were written successful.
+ */
+bool UnitNew_Save(FILE *fp)
+{
+	PoolFindStruct find;
+
+	find.houseID = HOUSE_INVALID;
+	find.type    = 0xFFFF;
+	find.index   = 0xFFFF;
+
+	while (true) {
+		Unit *u;
+		Unit su;
+
+		u = Unit_Find(&find);
+		if (u == NULL) break;
+		su = *u;
+
+		if (!SaveLoad_Save(s_saveUnitNewIndex, fp, &su.o)) return false;
+		if (!SaveLoad_Save(s_saveUnitNew, fp, &su)) return false;
+	}
+
+	return true;
+}
diff --git a/src/script/structure.c b/src/script/structure.c
index c4156ac19..06b9ecd50 100644
--- a/src/script/structure.c
+++ b/src/script/structure.c
@@ -521,11 +521,11 @@ uint16 Script_Structure_Fire(ScriptEngine *script)
 	if (s->o.type == STRUCTURE_ROCKET_TURRET && Tile_GetDistance(Tools_Index_GetTile(target), s->o.position) >= 0x300) {
 		type      = UNIT_MISSILE_TURRET;
 		damage    = 30;
-		fireDelay = Tools_AdjustToGameSpeed(g_table_unitInfo[UNIT_LAUNCHER].fireDelay, 1, 255, true);
+		fireDelay = Tools_AdjustToGameSpeed(g_table_unitInfo[UNIT_LAUNCHER].fireDelay, 1, 0xFFFF, true);
 	} else {
 		type      = UNIT_BULLET;
 		damage    = 20;
-		fireDelay = Tools_AdjustToGameSpeed(g_table_unitInfo[UNIT_TANK].fireDelay, 1, 255, true);
+		fireDelay = Tools_AdjustToGameSpeed(g_table_unitInfo[UNIT_TANK].fireDelay, 1, 0xFFFF, true);
 	}
 
 	position.tile = s->o.position.tile;
diff --git a/src/script/unit.c b/src/script/unit.c
index cf2e8119b..27d8a32dc 100644
--- a/src/script/unit.c
+++ b/src/script/unit.c
@@ -680,16 +680,16 @@ uint16 Script_Unit_Fire(ScriptEngine *script)
 		default: break;
 	}
 
-	u->fireDelay = Tools_AdjustToGameSpeed(clamp(ui->fireDelay * 2, 1, 255), 1, 255, true) & 0xFF;
+	u->fireDelay = Tools_AdjustToGameSpeed(ui->fireDelay * 2, 1, 0xFFFF, true);
 
 	if (fireTwice) {
 		u->o.flags.s.fireTwiceFlip = !u->o.flags.s.fireTwiceFlip;
-		if (u->o.flags.s.fireTwiceFlip) u->fireDelay = Tools_AdjustToGameSpeed(5, 1, 10, true) & 0xFF;
+		if (u->o.flags.s.fireTwiceFlip) u->fireDelay = Tools_AdjustToGameSpeed(5, 1, 10, true);
 	} else {
 		u->o.flags.s.fireTwiceFlip = false;
 	}
 
-	if (u->fireDelay != 255) u->fireDelay += Tools_Random_256() & 1;
+	u->fireDelay += Tools_Random_256() & 1;
 
 	Unit_UpdateMap(2, u);
 
diff --git a/src/unit.h b/src/unit.h
index fae8233c2..2598bf4c6 100644
--- a/src/unit.h
+++ b/src/unit.h
@@ -99,7 +99,7 @@ typedef struct Unit {
 	uint16 originEncoded;                                   /*!< Encoded index, indicating the origin. */
 	uint8  actionID;                                        /*!< Current action. */
 	uint8  nextActionID;                                    /*!< Next action. */
-	uint8  fireDelay;                                       /*!< Delay between firing. */
+	uint16 fireDelay;                                       /*!< Delay between firing. In Dune2 this is an uint8. */
 	uint16 distanceToDestination;                           /*!< How much distance between where we are now and where currentDestination is. */
 	uint16 targetAttack;                                    /*!< Target to attack (encoded index). */
 	uint16 targetMove;                                      /*!< Target to move to (encoded index). */
@@ -207,8 +207,6 @@ extern void Unit_Sort();
 extern Unit *Unit_Get_ByPackedTile(uint16 packed);
 extern uint16 Unit_IsValidMovementIntoStructure(Unit *unit, struct Structure *s);
 extern void Unit_SetDestination(Unit *u, uint16 destination);
-extern bool Unit_Save(FILE *fp);
-extern bool Unit_Load(FILE *fp, uint32 length);
 extern uint16 Unit_GetTargetUnitPriority(Unit *unit, Unit *target);
 extern uint16 Unit_FindClosestRefinery(Unit *unit);
 extern bool Unit_SetPosition(Unit *u, tile32 position);
